Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::Geometry Class Reference

Inheritance diagram for osg::Geometry:

[legend]
List of all members.

## Public Types
typedef std::vector< ArrayData > | ArrayList
typedef std::vector< ref_ptr< PrimitiveSet > > | PrimitiveSetList
enum | AttributeBinding { BIND_OFF = 0, BIND_OVERALL, BIND_PER_PRIMITIVE_SET, BIND_PER_PRIMITIVE, BIND_PER_VERTEX }
## Public Member Functions
| Geometry ()
| Geometry (const Geometry &geometry, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
virtual Object * | cloneType () const
| Clone the type of an object, with Object* return type.
virtual Object * | clone (const CopyOp &copyop) const
| Clone an object, with Object* return type.
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
| return the name of the object's library.
virtual const char * | className () const
| return the name of the object's class type.
virtual Geometry * | asGeometry ()
| Convert 'this' into a Geometry pointer if Drawable is a Geometry, otherwise return 0.
virtual const Geometry * | asGeometry () const
| Convert 'const this' into a const Geometry pointer if Drawable is a Geometry, otherwise return 0.
bool | empty () const
void | setVertexArray (Array *array)
Array * | getVertexArray ()
const Array * | getVertexArray () const
void | setVertexIndices (IndexArray *array)
IndexArray * | getVertexIndices ()
const IndexArray * | getVertexIndices () const
void | setVertexData (const ArrayData &arrayData)
ArrayData & | getVertexData ()
const ArrayData & | getVertexData () const
void | setNormalBinding (AttributeBinding ab)
AttributeBinding | getNormalBinding () const
void | setNormalArray (Array *array)
Array * | getNormalArray ()
const Array * | getNormalArray () const
void | setNormalIndices (IndexArray *array)
IndexArray * | getNormalIndices ()
const IndexArray * | getNormalIndices () const
void | setNormalData (const ArrayData &arrayData)
ArrayData & | getNormalData ()
const ArrayData & | getNormalData () const
void | setColorBinding (AttributeBinding ab)
AttributeBinding | getColorBinding () const
void | setColorArray (Array *array)
Array * | getColorArray ()
const Array * | getColorArray () const
void | setColorIndices (IndexArray *array)
IndexArray * | getColorIndices ()
const IndexArray * | getColorIndices () const
void | setColorData (const ArrayData &arrayData)
ArrayData & | getColorData ()
const ArrayData & | getColorData () const
void | setSecondaryColorBinding (AttributeBinding ab)
AttributeBinding | getSecondaryColorBinding () const
void | setSecondaryColorArray (Array *array)
Array * | getSecondaryColorArray ()
const Array * | getSecondaryColorArray () const
void | setSecondaryColorIndices (IndexArray *array)
IndexArray * | getSecondaryColorIndices ()
const IndexArray * | getSecondaryColorIndices () const
void | setSecondaryColorData (const ArrayData &arrayData)
ArrayData & | getSecondaryColorData ()
const ArrayData & | getSecondaryColorData () const
void | setFogCoordBinding (AttributeBinding ab)
AttributeBinding | getFogCoordBinding () const
void | setFogCoordArray (Array *array)
Array * | getFogCoordArray ()
const Array * | getFogCoordArray () const
void | setFogCoordIndices (IndexArray *array)
IndexArray * | getFogCoordIndices ()
const IndexArray * | getFogCoordIndices () const
void | setFogCoordData (const ArrayData &arrayData)
ArrayData & | getFogCoordData ()
const ArrayData & | getFogCoordData () const
void | setTexCoordArray (unsigned int unit, Array *)
Array * | getTexCoordArray (unsigned int unit)
const Array * | getTexCoordArray (unsigned int unit) const
void | setTexCoordIndices (unsigned int unit, IndexArray *)
IndexArray * | getTexCoordIndices (unsigned int unit)
const IndexArray * | getTexCoordIndices (unsigned int unit) const
void | setTexCoordData (unsigned int index, const ArrayData &arrayData)
ArrayData & | getTexCoordData (unsigned int index)
const ArrayData & | getTexCoordData (unsigned int index) const
unsigned int | getNumTexCoordArrays () const
ArrayList & | getTexCoordArrayList ()
const ArrayList & | getTexCoordArrayList () const
void | setVertexAttribArray (unsigned int index, Array *array)
Array * | getVertexAttribArray (unsigned int index)
const Array * | getVertexAttribArray (unsigned int index) const
void | setVertexAttribIndices (unsigned int index, IndexArray *array)
IndexArray * | getVertexAttribIndices (unsigned int index)
const IndexArray * | getVertexAttribIndices (unsigned int index) const
void | setVertexAttribBinding (unsigned int index, AttributeBinding ab)
AttributeBinding | getVertexAttribBinding (unsigned int index) const
void | setVertexAttribNormalize (unsigned int index, GLboolean norm)
GLboolean | getVertexAttribNormalize (unsigned int index) const
void | setVertexAttribData (unsigned int index, const ArrayData &arrayData)
ArrayData & | getVertexAttribData (unsigned int index)
const ArrayData & | getVertexAttribData (unsigned int index) const
unsigned int | getNumVertexAttribArrays () const
ArrayList & | getVertexAttribArrayList ()
const ArrayList & | getVertexAttribArrayList () const
void | setPrimitiveSetList (const PrimitiveSetList &primitives)
PrimitiveSetList & | getPrimitiveSetList ()
const PrimitiveSetList & | getPrimitiveSetList () const
unsigned int | getNumPrimitiveSets () const
PrimitiveSet * | getPrimitiveSet (unsigned int pos)
const PrimitiveSet * | getPrimitiveSet (unsigned int pos) const
bool | addPrimitiveSet (PrimitiveSet *primitiveset)
| Add a primitive set to the geometry.
bool | setPrimitiveSet (unsigned int i, PrimitiveSet *primitiveset)
| Set a primitive set to the specified position in geometry's primitive set list.
bool | insertPrimitiveSet (unsigned int i, PrimitiveSet *primitiveset)
| Insert a primitive set to the specified position in geometry's primitive set list.
bool | removePrimitiveSet (unsigned int i, unsigned int numElementsToRemove=1)
| Remove primitive set(s) from the specified position in geometry's primitive set list.
unsigned int | getPrimitiveSetIndex (const PrimitiveSet *primitiveset) const
| Get the index number of a primitive set, return a value between 0 and getNumPrimitiveSet()-1 if found, if not found then return getNumPrimitiveSet().
void | setFastPathHint (bool on)
| Set whether fast paths should be used when supported.
bool | getFastPathHint () const
| Get whether fast paths should be used when supported.
bool | areFastPathsUsed () const
| Return true if OpenGL fast paths will be used with drawing this Geometry.
bool | computeFastPathsUsed ()
bool | verifyBindings () const
void | computeCorrectBindingsAndArraySizes ()
bool | suitableForOptimization () const
void | copyToAndOptimize (Geometry &target)
void | computeInternalOptimizedGeometry ()
void | removeInternalOptimizedGeometry ()
void | setInternalOptimizedGeometry (osg::Geometry *geometry)
osg::Geometry * | getInternalOptimizedGeometry ()
const osg::Geometry * | getInternalOptimizedGeometry () const
virtual unsigned int | getGLObjectSizeHint () const
| Return the estimated size of GLObjects (display lists/vertex buffer objects) that are associated with this drawable.
virtual void | drawImplementation (State &state) const
| Draw Geometry directly ignoring an OpenGL display list which could be attached.
virtual bool | supports (const AttributeFunctor &) const
| Return true, osg::Geometry does support accept(AttributeFunctor&).
virtual void | accept (AttributeFunctor &af)
| Accept an AttributeFunctor and call its methods to tell it about the interal attributes that this Drawable has.
virtual bool | supports (const ConstAttributeFunctor &) const
| Return true, osg::Geometry does support accept(ConstAttributeFunctor&).
virtual void | accept (ConstAttributeFunctor &af) const
| Accept a ConstAttributeFunctor and call its methods to tell it about the interal attributes that this Drawable has.
virtual bool | supports (const PrimitiveFunctor &) const
| Return true, osg::Geometry does support accept(PrimitiveFunctor&).
virtual void | accept (PrimitiveFunctor &pf) const
| Accept a PrimitiveFunctor and call its methods to tell it about the interal primitives that this Drawable has.
virtual bool | supports (const PrimitiveIndexFunctor &) const
| Return true, osg::Geometry does support accept(PrimitiveIndexFunctor&).
virtual void | accept (PrimitiveIndexFunctor &pf) const
| Accept a PrimitiveFunctor and call its methods to tell it about the interal primitives that this Drawable has.
## Static Public Attributes
const ArrayData | s_InvalidArrayData
| Static ArrayData which is returned from getTexCoordData(i) const and getVertexAttribData(i) const when i is out of range.
## Protected Member Functions
Geometry & | operator= (const Geometry &)
virtual | ~Geometry ()
bool | verifyBindings (const ArrayData &arrayData) const
bool | verifyBindings (const Vec3ArrayData &arrayData) const
void | computeCorrectBindingsAndArraySizes (ArrayData &arrayData, const char *arrayName)
void | computeCorrectBindingsAndArraySizes (Vec3ArrayData &arrayData, const char *arrayName)
## Protected Attributes
PrimitiveSetList | _primitives
ArrayData | _vertexData
ArrayData | _normalData
ArrayData | _colorData
ArrayData | _secondaryColorData
ArrayData | _fogCoordData
ArrayList | _texCoordList
ArrayList | _vertexAttribList
bool | _fastPath
bool | _fastPathHint
ref_ptr< Geometry > | _internalOptimizedGeometry

## Member Typedef Documentation

typedef std::vector< ArrayData > osg::Geometry::ArrayList

typedef std::vector< ref_ptr<PrimitiveSet> > osg::Geometry::PrimitiveSetList

## Member Enumeration Documentation

enum osg::Geometry::AttributeBinding

  | Enumeration values:
  BIND_OFF |
  BIND_OVERALL |
  BIND_PER_PRIMITIVE_SET |
  BIND_PER_PRIMITIVE |
  BIND_PER_VERTEX |

## Constructor & Destructor Documentation

osg::Geometry::Geometry | ( |  | ) |

osg::Geometry::Geometry | ( | const Geometry & | geometry,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

virtual osg::Geometry::~Geometry | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void osg::Geometry::accept | ( | PrimitiveIndexFunctor & | pf | ) | const`[virtual]`

| Accept a PrimitiveFunctor and call its methods to tell it about the interal primitives that this Drawable has. Reimplemented from osg::Drawable.

virtual void osg::Geometry::accept | ( | PrimitiveFunctor & | pf | ) | const`[virtual]`

| Accept a PrimitiveFunctor and call its methods to tell it about the interal primitives that this Drawable has. Reimplemented from osg::Drawable.

virtual void osg::Geometry::accept | ( | ConstAttributeFunctor & | af | ) | const`[virtual]`

| Accept a ConstAttributeFunctor and call its methods to tell it about the interal attributes that this Drawable has. Reimplemented from osg::Drawable.

virtual void osg::Geometry::accept | ( | AttributeFunctor & | af | ) | `[virtual]`

| Accept an AttributeFunctor and call its methods to tell it about the interal attributes that this Drawable has. Reimplemented from osg::Drawable.

bool osg::Geometry::addPrimitiveSet | ( | PrimitiveSet * | primitiveset | ) |

| Add a primitive set to the geometry.

bool osg::Geometry::areFastPathsUsed | ( |  | ) | const`[inline]`

| Return true if OpenGL fast paths will be used with drawing this Geometry. Fast paths use vertex arrays, and glDrawArrays/glDrawElements. Slow paths use glBegin()/glVertex.../glEnd(). Use of per primitive bindings or per vertex indexed arrays will drop the rendering path off the fast path.

virtual const Geometry* osg::Geometry::asGeometry | ( |  | ) | const`[inline, virtual]`

| Convert 'const this' into a const Geometry pointer if Drawable is a Geometry, otherwise return 0. Equivalent to dynamic_cast<const Geometry*>(this). Reimplemented from osg::Drawable.

virtual Geometry* osg::Geometry::asGeometry | ( |  | ) | `[inline, virtual]`

| Convert 'this' into a Geometry pointer if Drawable is a Geometry, otherwise return 0. Equivalent to dynamic_cast<Geometry*>(this). Reimplemented from osg::Drawable.

virtual const char* osg::Geometry::className | ( |  | ) | const`[inline, virtual]`

| return the name of the object's class type. Must be defined by derived classes. Reimplemented from osg::Drawable.

virtual Object* osg::Geometry::clone | ( | const CopyOp & | copyop | ) | const`[inline, virtual]`

| Clone an object, with Object* return type. Must be defined by derived classes. Implements osg::Object.

virtual Object* osg::Geometry::cloneType | ( |  | ) | const`[inline, virtual]`

| Clone the type of an object, with Object* return type. Must be defined by derived classes. Implements osg::Object.

void osg::Geometry::computeCorrectBindingsAndArraySizes | ( | Vec3ArrayData & | arrayData,
|  | const char * | arrayName
| ) | `[protected]`

void osg::Geometry::computeCorrectBindingsAndArraySizes | ( | ArrayData & | arrayData,
|  | const char * | arrayName
| ) | `[protected]`

void osg::Geometry::computeCorrectBindingsAndArraySizes | ( |  | ) |

bool osg::Geometry::computeFastPathsUsed | ( |  | ) |

void osg::Geometry::computeInternalOptimizedGeometry | ( |  | ) |

void osg::Geometry::copyToAndOptimize | ( | Geometry & | target | ) |

virtual void osg::Geometry::drawImplementation | ( | State & | state | ) | const`[virtual]`

| Draw Geometry directly ignoring an OpenGL display list which could be attached. This is the internal draw method which does the drawing itself, and is the method to override when deriving from Geometry for user-drawn objects. Implements osg::Drawable.

bool osg::Geometry::empty | ( |  | ) | const

const Array* osg::Geometry::getColorArray | ( |  | ) | const`[inline]`

Array* osg::Geometry::getColorArray | ( |  | ) | `[inline]`

AttributeBinding osg::Geometry::getColorBinding | ( |  | ) | const`[inline]`

const ArrayData& osg::Geometry::getColorData | ( |  | ) | const`[inline]`

ArrayData& osg::Geometry::getColorData | ( |  | ) | `[inline]`

const IndexArray* osg::Geometry::getColorIndices | ( |  | ) | const`[inline]`

IndexArray* osg::Geometry::getColorIndices | ( |  | ) | `[inline]`

bool osg::Geometry::getFastPathHint | ( |  | ) | const`[inline]`

| Get whether fast paths should be used when supported.

const Array* osg::Geometry::getFogCoordArray | ( |  | ) | const`[inline]`

Array* osg::Geometry::getFogCoordArray | ( |  | ) | `[inline]`

AttributeBinding osg::Geometry::getFogCoordBinding | ( |  | ) | const`[inline]`

const ArrayData& osg::Geometry::getFogCoordData | ( |  | ) | const`[inline]`

ArrayData& osg::Geometry::getFogCoordData | ( |  | ) | `[inline]`

const IndexArray* osg::Geometry::getFogCoordIndices | ( |  | ) | const`[inline]`

IndexArray* osg::Geometry::getFogCoordIndices | ( |  | ) | `[inline]`

virtual unsigned int osg::Geometry::getGLObjectSizeHint | ( |  | ) | const`[virtual]`

| Return the estimated size of GLObjects (display lists/vertex buffer objects) that are associated with this drawable. This size is used a hint for reuse of deleteed display lists/vertex buffer objects. Reimplemented from osg::Drawable.

const osg::Geometry* osg::Geometry::getInternalOptimizedGeometry | ( |  | ) | const`[inline]`

osg::Geometry* osg::Geometry::getInternalOptimizedGeometry | ( |  | ) | `[inline]`

const Array* osg::Geometry::getNormalArray | ( |  | ) | const`[inline]`

Array* osg::Geometry::getNormalArray | ( |  | ) | `[inline]`

AttributeBinding osg::Geometry::getNormalBinding | ( |  | ) | const`[inline]`

const ArrayData& osg::Geometry::getNormalData | ( |  | ) | const`[inline]`

ArrayData& osg::Geometry::getNormalData | ( |  | ) | `[inline]`

const IndexArray* osg::Geometry::getNormalIndices | ( |  | ) | const`[inline]`

IndexArray* osg::Geometry::getNormalIndices | ( |  | ) | `[inline]`

unsigned int osg::Geometry::getNumPrimitiveSets | ( |  | ) | const`[inline]`

unsigned int osg::Geometry::getNumTexCoordArrays | ( |  | ) | const`[inline]`

unsigned int osg::Geometry::getNumVertexAttribArrays | ( |  | ) | const`[inline]`

const PrimitiveSet* osg::Geometry::getPrimitiveSet | ( | unsigned int | pos | ) | const`[inline]`

PrimitiveSet* osg::Geometry::getPrimitiveSet | ( | unsigned int | pos | ) | `[inline]`

unsigned int osg::Geometry::getPrimitiveSetIndex | ( | const PrimitiveSet * | primitiveset | ) | const

| Get the index number of a primitive set, return a value between 0 and getNumPrimitiveSet()-1 if found, if not found then return getNumPrimitiveSet(). When checking for a valid find value use if ((value=geometry->getPrimitiveSetIndex(primitive))!=geometry.getNumPrimitiveSet())

const PrimitiveSetList& osg::Geometry::getPrimitiveSetList | ( |  | ) | const`[inline]`

PrimitiveSetList& osg::Geometry::getPrimitiveSetList | ( |  | ) | `[inline]`

const Array* osg::Geometry::getSecondaryColorArray | ( |  | ) | const`[inline]`

Array* osg::Geometry::getSecondaryColorArray | ( |  | ) | `[inline]`

AttributeBinding osg::Geometry::getSecondaryColorBinding | ( |  | ) | const`[inline]`

const ArrayData& osg::Geometry::getSecondaryColorData | ( |  | ) | const`[inline]`

ArrayData& osg::Geometry::getSecondaryColorData | ( |  | ) | `[inline]`

const IndexArray* osg::Geometry::getSecondaryColorIndices | ( |  | ) | const`[inline]`

IndexArray* osg::Geometry::getSecondaryColorIndices | ( |  | ) | `[inline]`

const Array* osg::Geometry::getTexCoordArray | ( | unsigned int | unit | ) | const

Array* osg::Geometry::getTexCoordArray | ( | unsigned int | unit | ) |

const ArrayList& osg::Geometry::getTexCoordArrayList | ( |  | ) | const`[inline]`

ArrayList& osg::Geometry::getTexCoordArrayList | ( |  | ) | `[inline]`

const ArrayData& osg::Geometry::getTexCoordData | ( | unsigned int | index | ) | const

ArrayData& osg::Geometry::getTexCoordData | ( | unsigned int | index | ) |

const IndexArray* osg::Geometry::getTexCoordIndices | ( | unsigned int | unit | ) | const

IndexArray* osg::Geometry::getTexCoordIndices | ( | unsigned int | unit | ) |

const Array* osg::Geometry::getVertexArray | ( |  | ) | const`[inline]`

Array* osg::Geometry::getVertexArray | ( |  | ) | `[inline]`

const Array* osg::Geometry::getVertexAttribArray | ( | unsigned int | index | ) | const

Array* osg::Geometry::getVertexAttribArray | ( | unsigned int | index | ) |

const ArrayList& osg::Geometry::getVertexAttribArrayList | ( |  | ) | const`[inline]`

ArrayList& osg::Geometry::getVertexAttribArrayList | ( |  | ) | `[inline]`

AttributeBinding osg::Geometry::getVertexAttribBinding | ( | unsigned int | index | ) | const

const ArrayData& osg::Geometry::getVertexAttribData | ( | unsigned int | index | ) | const

ArrayData& osg::Geometry::getVertexAttribData | ( | unsigned int | index | ) |

const IndexArray* osg::Geometry::getVertexAttribIndices | ( | unsigned int | index | ) | const

IndexArray* osg::Geometry::getVertexAttribIndices | ( | unsigned int | index | ) |

GLboolean osg::Geometry::getVertexAttribNormalize | ( | unsigned int | index | ) | const

const ArrayData& osg::Geometry::getVertexData | ( |  | ) | const`[inline]`

ArrayData& osg::Geometry::getVertexData | ( |  | ) | `[inline]`

const IndexArray* osg::Geometry::getVertexIndices | ( |  | ) | const`[inline]`

IndexArray* osg::Geometry::getVertexIndices | ( |  | ) | `[inline]`

bool osg::Geometry::insertPrimitiveSet | ( | unsigned int | i,
|  | PrimitiveSet * | primitiveset
| ) |

| Insert a primitive set to the specified position in geometry's primitive set list.

virtual bool osg::Geometry::isSameKindAs | ( | const Object * | obj | ) | const`[inline, virtual]`

| Reimplemented from osg::Drawable.

virtual const char* osg::Geometry::libraryName | ( |  | ) | const`[inline, virtual]`

| return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name. Reimplemented from osg::Drawable.

Geometry& osg::Geometry::operator= | ( | const Geometry & |  | ) | `[inline, protected]`

void osg::Geometry::removeInternalOptimizedGeometry | ( |  | ) | `[inline]`

bool osg::Geometry::removePrimitiveSet | ( | unsigned int | i,
|  | unsigned int | numElementsToRemove = 1
| ) |

| Remove primitive set(s) from the specified position in geometry's primitive set list.

void osg::Geometry::setColorArray | ( | Array * | array | ) | `[inline]`

void osg::Geometry::setColorBinding | ( | AttributeBinding | ab | ) | `[inline]`

void osg::Geometry::setColorData | ( | const ArrayData & | arrayData | ) | `[inline]`

void osg::Geometry::setColorIndices | ( | IndexArray * | array | ) | `[inline]`

void osg::Geometry::setFastPathHint | ( | bool | on | ) | `[inline]`

| Set whether fast paths should be used when supported.

void osg::Geometry::setFogCoordArray | ( | Array * | array | ) | `[inline]`

void osg::Geometry::setFogCoordBinding | ( | AttributeBinding | ab | ) | `[inline]`

void osg::Geometry::setFogCoordData | ( | const ArrayData & | arrayData | ) | `[inline]`

void osg::Geometry::setFogCoordIndices | ( | IndexArray * | array | ) | `[inline]`

void osg::Geometry::setInternalOptimizedGeometry | ( | osg::Geometry * | geometry | ) | `[inline]`

void osg::Geometry::setNormalArray | ( | Array * | array | ) | `[inline]`

void osg::Geometry::setNormalBinding | ( | AttributeBinding | ab | ) | `[inline]`

void osg::Geometry::setNormalData | ( | const ArrayData & | arrayData | ) | `[inline]`

void osg::Geometry::setNormalIndices | ( | IndexArray * | array | ) | `[inline]`

bool osg::Geometry::setPrimitiveSet | ( | unsigned int | i,
|  | PrimitiveSet * | primitiveset
| ) |

| Set a primitive set to the specified position in geometry's primitive set list.

void osg::Geometry::setPrimitiveSetList | ( | const PrimitiveSetList & | primitives | ) | `[inline]`

void osg::Geometry::setSecondaryColorArray | ( | Array * | array | ) | `[inline]`

void osg::Geometry::setSecondaryColorBinding | ( | AttributeBinding | ab | ) | `[inline]`

void osg::Geometry::setSecondaryColorData | ( | const ArrayData & | arrayData | ) | `[inline]`

void osg::Geometry::setSecondaryColorIndices | ( | IndexArray * | array | ) | `[inline]`

void osg::Geometry::setTexCoordArray | ( | unsigned int | unit,
|  | Array * |
| ) |

void osg::Geometry::setTexCoordData | ( | unsigned int | index,
|  | const ArrayData & | arrayData
| ) |

void osg::Geometry::setTexCoordIndices | ( | unsigned int | unit,
|  | IndexArray * |
| ) |

void osg::Geometry::setVertexArray | ( | Array * | array | ) | `[inline]`

void osg::Geometry::setVertexAttribArray | ( | unsigned int | index,
|  | Array * | array
| ) |

void osg::Geometry::setVertexAttribBinding | ( | unsigned int | index,
|  | AttributeBinding | ab
| ) |

void osg::Geometry::setVertexAttribData | ( | unsigned int | index,
|  | const ArrayData & | arrayData
| ) |

void osg::Geometry::setVertexAttribIndices | ( | unsigned int | index,
|  | IndexArray * | array
| ) |

void osg::Geometry::setVertexAttribNormalize | ( | unsigned int | index,
|  | GLboolean | norm
| ) |

void osg::Geometry::setVertexData | ( | const ArrayData & | arrayData | ) | `[inline]`

void osg::Geometry::setVertexIndices | ( | IndexArray * | array | ) | `[inline]`

bool osg::Geometry::suitableForOptimization | ( |  | ) | const

virtual bool osg::Geometry::supports | ( | const PrimitiveIndexFunctor & |  | ) | const`[inline, virtual]`

| Return true, osg::Geometry does support accept(PrimitiveIndexFunctor&). Reimplemented from osg::Drawable.

virtual bool osg::Geometry::supports | ( | const PrimitiveFunctor & |  | ) | const`[inline, virtual]`

| Return true, osg::Geometry does support accept(PrimitiveFunctor&). Reimplemented from osg::Drawable.

virtual bool osg::Geometry::supports | ( | const ConstAttributeFunctor & |  | ) | const`[inline, virtual]`

| Return true, osg::Geometry does support accept(ConstAttributeFunctor&). Reimplemented from osg::Drawable.

virtual bool osg::Geometry::supports | ( | const AttributeFunctor & |  | ) | const`[inline, virtual]`

| Return true, osg::Geometry does support accept(AttributeFunctor&). Reimplemented from osg::Drawable.

bool osg::Geometry::verifyBindings | ( | const Vec3ArrayData & | arrayData | ) | const`[protected]`

bool osg::Geometry::verifyBindings | ( | const ArrayData & | arrayData | ) | const`[protected]`

bool osg::Geometry::verifyBindings | ( |  | ) | const

## Member Data Documentation

ArrayData osg::Geometry::_colorData`[protected]`

bool osg::Geometry::_fastPath`[mutable, protected]`

bool osg::Geometry::_fastPathHint`[protected]`

ArrayData osg::Geometry::_fogCoordData`[protected]`

ref_ptr<Geometry> osg::Geometry::_internalOptimizedGeometry`[protected]`

ArrayData osg::Geometry::_normalData`[protected]`

PrimitiveSetList osg::Geometry::_primitives`[protected]`

ArrayData osg::Geometry::_secondaryColorData`[protected]`

ArrayList osg::Geometry::_texCoordList`[protected]`

ArrayList osg::Geometry::_vertexAttribList`[protected]`

ArrayData osg::Geometry::_vertexData`[protected]`

const ArrayData osg::Geometry::s_InvalidArrayData`[static]`

| Static ArrayData which is returned from getTexCoordData(i) const and getVertexAttribData(i) const when i is out of range.

The documentation for this class was generated from the following file:

- Geometry